/**
 * Copyright (c) 2010-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the New BSD License (3-clause license).
 *
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the New BSD License (3-clause license)
 * for more details.
 *
 * You should have received a copy of the New BSD License (3-clause license)
 * along with this program/library; If not, see http://directory.fsf.org/wiki/License:BSD_3Clause/
 * for the New BSD License (3-clause license).
 */
package com.ebmwebsourcing.easycommons.thread;

/**
 * @author Olivier Fabre - EBM WebSourcing
 */
public final class InheritableThreadContext {

    private static InheritableThreadLocal<ConcurrentHashMapWithDefaults<String, Object>> itl;

    static {
        reset();
    }

    private InheritableThreadContext() {
    }

    public static final void reset() {
        itl = new InheritableThreadLocal<ConcurrentHashMapWithDefaults<String, Object>>() {
            @Override
            protected ConcurrentHashMapWithDefaults<String, Object> initialValue() {
                return new ConcurrentHashMapWithDefaults<String, Object>();
            }

            @Override
            protected ConcurrentHashMapWithDefaults<String, Object> childValue(
                    ConcurrentHashMapWithDefaults<String, Object> parentValue) {
                ConcurrentHashMapWithDefaults<String, Object> childValue = new ConcurrentHashMapWithDefaults<String, Object>(
                        parentValue);
                return childValue;
            }
        };
    }

    public static final ConcurrentHashMapWithDefaults<String, Object> getParameters() {
        return itl.get();
    }

}
